#ifndef EO_BASE_EO_HH
#define EO_BASE_EO_HH
#include <Eo.h>

extern "C" {
#include "eo_base.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace eo { 
struct Base;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::eo::Base> : ::std::true_type {}; } }

namespace eo_cxx {
namespace eo { 
struct Base {
    ::eo::Base parent_get() const;
   void parent_set( ::efl::eolian::in_traits< ::eo::Base>::type parent) const;
    ::efl::eina::string_view name_get() const;
   void name_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
    ::efl::eina::string_view comment_get() const;
   void comment_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type comment) const;
   int event_global_freeze_count_get() const;
   int event_freeze_count_get() const;
   bool finalized_get() const;
   void* key_data_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   void key_data_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits<void const*>::type data) const;
    ::eo::Base key_obj_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   void key_obj_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits< ::eo::Base>::type objdata) const;
   void del() const;
    ::eo::Base provider_find( ::efl::eolian::in_traits< ::eo::Base>::type klass) const;
    ::eo::Base constructor() const;
   void destructor() const;
    ::eo::Base finalize() const;
    ::eo::Base name_find( ::efl::eolian::in_traits< ::efl::eina::string_view>::type search) const;
   void wref_add( ::efl::eolian::out_traits< ::eo::Base>::type wref) const;
   void wref_del( ::efl::eolian::out_traits< ::eo::Base>::type wref) const;
   void event_thaw() const;
   void event_freeze() const;
   void event_global_thaw() const;
   void event_global_freeze() const;
   void event_callback_stop() const;
    ::efl::eina::iterator< ::eo::Base> children_iterator_new() const;
   bool composite_attach( ::efl::eolian::in_traits< ::eo::Base>::type comp_obj) const;
   bool composite_detach( ::efl::eolian::in_traits< ::eo::Base>::type comp_obj) const;
   bool composite_part_is() const;
   static Eo_Class const* _eo_class()
   {
      return EO_BASE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::eo::Base() const;
   operator ::eo::Base&();
   operator ::eo::Base const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Base const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace eo { 
struct Base : ::efl::eo::concrete
{
   explicit Base( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Base(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Base(Base const& other) = default;
   Base(Base&& other) = default;
   Base& operator=(Base const& other) = default;
   Base& operator=(Base&& other) = default;
   Base()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Base( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Base(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
    ::eo::Base parent_get() const;
   void parent_set( ::efl::eolian::in_traits< ::eo::Base>::type parent) const;
    ::efl::eina::string_view name_get() const;
   void name_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type name) const;
    ::efl::eina::string_view comment_get() const;
   void comment_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type comment) const;
   int event_global_freeze_count_get() const;
   int event_freeze_count_get() const;
   bool finalized_get() const;
   void* key_data_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   void key_data_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits<void const*>::type data) const;
    ::eo::Base key_obj_get( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   void key_obj_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits< ::eo::Base>::type objdata) const;
   void del() const;
    ::eo::Base provider_find( ::efl::eolian::in_traits< ::eo::Base>::type klass) const;
    ::eo::Base constructor() const;
   void destructor() const;
    ::eo::Base finalize() const;
    ::eo::Base name_find( ::efl::eolian::in_traits< ::efl::eina::string_view>::type search) const;
   void wref_add( ::efl::eolian::out_traits< ::eo::Base>::type wref) const;
   void wref_del( ::efl::eolian::out_traits< ::eo::Base>::type wref) const;
   void event_thaw() const;
   void event_freeze() const;
   void event_global_thaw() const;
   void event_global_freeze() const;
   void event_callback_stop() const;
    ::efl::eina::iterator< ::eo::Base> children_iterator_new() const;
   bool composite_attach( ::efl::eolian::in_traits< ::eo::Base>::type comp_obj) const;
   bool composite_detach( ::efl::eolian::in_traits< ::eo::Base>::type comp_obj) const;
   bool composite_part_is() const;
   static Eo_Class const* _eo_class()
   {
      return EO_BASE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct callback_add_event
   {
      static Eo_Event_Description const* description()
      { return EO_EVENT_CALLBACK_ADD; }
      typedef void parameter_type;
   } const callback_add_event;
   static struct callback_del_event
   {
      static Eo_Event_Description const* description()
      { return EO_EVENT_CALLBACK_DEL; }
      typedef void parameter_type;
   } const callback_del_event;
   static struct del_event
   {
      static Eo_Event_Description const* description()
      { return EO_EVENT_DEL; }
      typedef void parameter_type;
   } const del_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Base> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Base const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Base) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Base>::value, "");
} 
#include "eo_base.eo.impl.hh"
#endif
